#include "RT_HW_BOARDS.h"	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  ЧТЕНИЕ С ДИСКРЕТНОГО ПИНА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_BOARDS:: pinDigitalRead (uint8_t &dir, int8_t pin, char mode, char inv){
switch(dir){
  case 0: if(!checkPin(RT_HW_INDEX_PINS_DIN,pin)) {dir=7; return 0;}	//--Проверка  пина. Если недопустимый, то выход с id.dir=7;
	 switch(mode){
		case 'I': pinMode(pin, RT_HW_IO_MODE_INPUT); 			break;	//--дискретный вход обычный;
		case 'U': pinMode(pin, RT_HW_IO_MODE_INPUT_PULLUP);		break;	//--дискретный вход с подтяжкой к +Vcc;
		case 'D': pinMode(pin, RT_HW_IO_MODE_INPUT_PULLDOWN);	break;	//--с подтяжкой к Gnd;											
		case 'F': pinMode(pin, RT_HW_IO_MODE_INPUT);			break;};//--дискретный вход - аналог INPUT; 	
			 dir++;
  case 1: if(inv!='Y') return  digitalRead(pin); return !digitalRead(pin);
  case 7: if(inv!='Y') return 0; return 1; }};  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//				ЧТЕНИЕ С АНАЛОГОВОГО ПИНА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint16_t RT_HW_BOARDS:: pinAnalogRead(uint8_t &dir, uint16_t &ago, uint16_t &sensor, int8_t pin){
switch(dir){
  case 0: if(!checkPin(RT_HW_INDEX_PINS_ADC,pin)) {dir=7; return 0;}	//--Проверка  пина. Если недопустимый, то выход с id.dir=7;
		  pinMode(pin, RT_HW_IO_MODE_INPUT_ANALOG);	dir++;				//--Настройка пина на аналоговый ввод; 	
  case 1: sensor=analogRead(pin); 
		  buff.v16=ago;								//--Сохраняем в буфере предыдущее значение (очищенное от дрейфа);
	      buff.vm16=maxBitDepth(depth.adc); 		//--Сохраняем в буфере максимально для ADC значение;
	      if(sensor > buff.vm16){sensor=buff.vm16;}	//--Ограничение показаний сверху;
		  if(sensor > buff.v16) {if((sensor - buff.v16) > depth.adc_drift)  buff.v16=sensor;} 	//--Нормализация 
		  if(sensor < buff.v16) {if((buff.v16 - sensor) > depth.adc_drift)  buff.v16=sensor;}	//   дрейфа показаний;	  
		  if((buff.vm16-buff.v16)<=depth.adc_drift) {buff.v16=maxBitDepth(depth.adc);}			//--Корректировка значения сверху (по дрейфу показаний); 
		  if(buff.v16<=depth.adc_null) {buff.v16=0;}//--Корректировка значения снизу  (по дрейфу нуля);    
		  if(ago!= buff.v16) {ago= buff.v16;}   	//--Если данные изменились, устанавливается флаг "Обновление данных";	 
		  return normADC(ago); 						//--Возвращает нормализованное значение; 				 
  case 7: return 0;}}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  ЧТЕНИЕ С СЕНСОРНОГО ПИНА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint16_t RT_HW_BOARDS:: pinTouchRead (uint8_t &dir, int8_t pin){
#ifdef RT_HW_GROUP_ESP32
switch(dir){
  case 0: if(!checkPin(RT_HW_INDEX_PINS_DIN,pin)) {dir=7; return 0;}	//--Проверка  пина. Если недопустимый, то выход с id.dir=7;
		  pinMode(pin, RT_HW_IO_MODE_INPUT);	dir++;					//--Настройка пина на ввод; 	
  case 1: return touchRead(pin);		
  case 7: return 0;}
#endif  
return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ЧТЕНИЕ ВСТРОЕННОГО ДАТЧИКА ХОЛЛА [ESP32]
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int16_t RT_HW_BOARDS:: pinHall(){
#ifdef RT_HW_GROUP_ESP32
		return hallRead();
#endif
return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ДИСКРЕТНЫЙ ВЫВОД 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BOARDS:: pinDigitalWrite (uint8_t &dir, uint8_t &ago, int8_t pin, char open, char change, bool val){
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_DOT,pin)){dir=7; return;}	//--Проверка  пина. Если недопустимый, то выход с id.dir=1;
			if(open=='Y') pinMode(pin,RT_HW_IO_MODE_OUTPUT_OPEN_DRAIN);		//--Настройка пина как открытый выход;
			else  pinMode(pin,RT_HW_IO_MODE_OUTPUT);					    //--Настройка пина как обычный выход; 
			if(val) ago=0; else ago=1; dir++; 
	case 1:	if(ago!=val) {ago=(uint8_t)val; digitalWrite(pin,val); if(change!='Y') dir++;}; break;
	case 2: digitalWrite(pin,val); break;
	case 7: break;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ДИСКРЕТНЫЙ ВЫВОД  - МЕРЦАНИЕ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BOARDS:: pinDigitalBlink (uint8_t &dir, uint8_t &ago, int8_t pin){
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_DOT,pin)){dir=7; return;}	//--Проверка  пина. Если недопустимый, то выход с id.dir=1;
			pinMode(pin,RT_HW_IO_MODE_OUTPUT);					    //--Настройка пина как обычный выход; 
			dir++; 
	case 1:	if(ago) ago=0; else ago=1; digitalWrite(pin,ago); return;
	case 7: return;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ШИМ ВЫВОД  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BOARDS:: pinPWM (uint8_t &dir, uint8_t &num, uint16_t &device, int8_t pin, char open, uint16_t freq, uint16_t val){
if(val>maxBitDepth(depth.pwm)) {device=maxBitDepth(depth.pwm);} else device=val;
//-----------------------------------------------------------------------------
#ifdef 	RT_HW_GROUP_ARDUINO	
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_PWM,pin)){dir=7; return;}	;
		    pinMode(pin,OUTPUT); dir++;			//--Настройка;
	case 1: device=normPWM(val);
			analogWrite(pin,device); return;	//--Вывод ШИМ;
	case 7: return;}							//--Заглушка;
#endif	
//-----------------------------------------------------------------------------
#ifdef 	RT_HW_GROUP_ESP8266	
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_PWM,pin)){dir=7; return;}	;
		    pinMode(pin,OUTPUT); analogWriteFreq(constrain(freq, 100,10000)); dir++;
	case 1: device=normPWM(val);
			analogWrite(pin,device); return;	//--Вывод ШИМ;
	case 7: return;}							//--Заглушка;		
#endif	
//-----------------------------------------------------------------------------		
#ifdef  RT_HW_GROUP_ESP32
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_PWM,pin)){dir=7; return;}	;
			buff.iv16=getFistBitUint16(pwmChannelFlag);			//--Получение номера свободного каналов PWM(переменная pwmChannelFlag);
			if(buff.iv16<0){dir=7; return;} else num=buff.iv16; //--Если все каналы заняты(num<0), выход со сбросом флага id.ok;
			bitSet(pwmChannelFlag,num);    						//--Установка флага занятости канала;
			ledcSetup(num,constrain(freq,100,40000),depth.pwm);	//--Настройка канала id.channel: частота и разрешение;
			ledcAttachPin(pin, num);			    			//--Настройка:ШИМ        вывод[PWM]
			dir++;
	case 1: device=normPWM(val);
			ledcWrite (num,device);	return;	//--Вывод ШИМ;
	case 7: return;}						//--Заглушка;
#endif
//-----------------------------------------------------------------------------
#ifdef 	RT_HW_GROUP_STM32F1	
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_PWM,pin)){dir=7; return;}	;
		    if(open=='Y'){pinMode(pin,PWM_OPEN_DRAIN);} else {pinMode(pin,PWM);} dir++;	//--Настройка;
	case 1: device=normPWM(val);
			pwmWrite(pin,device); return;	//--Вывод ШИМ;
	case 7: return;}							//--Заглушка;		
#endif
//-----------------------------------------------------------------------------
#ifdef 	RT_HW_GROUP_STM32F4	
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_PWM,pin)){dir=7; return;}	;
		    if(open=='Y'){pinMode(pin,PWM_OPEN_DRAIN);} else {pinMode(pin,PWM);} dir++;	//--Настройка;
	case 1: device=normPWM(val);
			pwmWrite(pin,device); return;	//--Вывод ШИМ;
	case 7: return;}						//--Заглушка;		
#endif	   
//-----------------------------------------------------------------------------
return;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ВЫВОД DAC
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BOARDS:: pinDAC (uint8_t &dir, uint16_t &device, int8_t pin, uint16_t val){
if(val>maxBitDepth(depth.dac)) {device=maxBitDepth(depth.dac);} else device=val;
//-----------------------------------------------------------------------------
#ifdef 	RT_HW_GROUP_ARDUINO	
#if 	RT_HW_DEFINED_SAM3X8E  
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_DAC,pin)){dir=7; return;}	;
			dir++;							//--Настройка: заглушка (требует дополнительного изучения);
	case 1: return;							//--Вывод ШИМ: заглушка (требует дополнительного изучения);
	case 7: return;}						//--Заглушка;
	//--Заглушка;
#endif	
#endif	
//-----------------------------------------------------------------------------		
#ifdef  RT_HW_GROUP_ESP32
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_DAC,pin)){dir=7; return;}	;
			pinMode(pin,OUTPUT); dir++;	//--Настройка;
	case 1: device=normDAC(val);
			dacWrite(pin,device);		//--Вывод;
	case 7: return;}					//--Заглушка;
#endif
//-----------------------------------------------------------------------------
#ifdef 	RT_HW_GROUP_STM32F1	
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_DAC,pin)){dir=7; return;}	;
			//pinMode(pin,OUTPUT); 
			dir++;	//--Настройка;
	case 1: device=normDAC(val);
			//Serial.print("stm32F1 dac pin=");Serial.print(pin);Serial.print(" device=");Serial.println(device);
			analogWrite(pin,device);	//--Вывод;
	case 7: return;}						//--Заглушка;		
#endif
//-----------------------------------------------------------------------------
#ifdef 	RT_HW_GROUP_STM32F4	
  switch(dir){
	case 0: if(!checkPin(RT_HW_INDEX_PINS_DAC,pin)){dir=7; return;}	;
			pinMode(pin, OUTPUT); dir++;	//--Настройка;
	case 1: device=normDAC(val);
			analogWrite(pin,device);			//--Вывод;
	case 7: return;}						//--Заглушка;		
#endif	   
//-----------------------------------------------------------------------------
return;};




