#include "RT_HW_CONSOLE.h"					   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	      
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_CONSOLE:: genTick(){
  if(RT_HW_CONSOLE_MILLIS>=hive.timePeriod) {hive.timePeriod=RT_HW_CONSOLE_MILLIS+RT_HW_CONSOLE_PERIOD_TICK; 
  hive.blinkCnt++; hive.blink=!hive.blink;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	    (ust<100)  50 ;
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++i
bool RT_HW_CONSOLE:: eventID (RT_HW_CONSOLE_EVENT_ID &id, uint8_t ust){  
  if(ust==0) {id.period=1; return id.period;}
  if(id.eventCnt==hive.blinkCnt) {return id.period;}
  do{if(++id.cnt>ust) {id.eventCnt=hive.blinkCnt; id.blink=!id.blink; id.cnt=1; id.period=1; break;} 
     id.eventCnt++; if(id.eventCnt==hive.blinkCnt) break;} while(1);
return id.period;}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		   
//  speed:  UART; permit:   ;  
//  headSetMess: 
//	 =1 -  " "     " ";
//	 =0 -  " "     hive.resetHead   1    " ";
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_CONSOLE:: init(uint32_t speed, bool permit, bool headSetMess) {
	genTick();													//--  ;
  switch(hive.dir){default: hive.dir=0; 						//--  ;.
	case 0: hive.ready=hive.head=hive.mess=hive.resetHead=false;//-- 
			if(!permit) break;						hive.dir++; //-- "  ";
    case 1: Serial.begin(speed);					hive.dir++;	//-- ; 
	case 2: if(!Serial)	break; hive.blinkCnt=0;		hive.dir++;	//--  Serial  (!!!   DUE, ST32F103  .);
			//Serial.println('\n');								//--   ;
	case 3: if(hive.blinkCnt<=2) break; 						//-- 100,        
			hive.ready=hive.head=true; if(headSetMess) hive.mess=true;//--  :1) 2) ; 3) ,    headSetMess;
		               							    hive.dir++;	//--   ;		                                           
	case 4:	if(hive.resetHead){hive.resetHead=hive.head=false;}	//--  ""   ;
			if(hive.head && (hive.blinkCnt<=22)) break;  		//--  hive.head -      - 1 ; 
			hive.head=false; hive.mess=true; hive.dir++; //--  " "    " ";	
			
	case 5: break;}};											//-- ;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char    RT_HW_CONSOLE::boolToChar (bool val, char sign_0, char sign_1){if(val) return sign_1; else return sign_0;};	//-- bool  char; 
uint8_t RT_HW_CONSOLE::getLenBegin(uint8_t len, uint8_t src, char alig){ if(len<=src) return 0; switch(alig){default:return 0; case 'C':return (len-src-(len-src)/2);              case 'R':return (len-src);}}; //---  ; 
uint8_t RT_HW_CONSOLE::getLenEnd  (uint8_t len, uint8_t src, char alig){ if(len<=src) return 0; switch(alig){default:return 0; case 'C':return (len-src-getLenBegin(len,src,alig));case 'L':return (len-src);}}; //---  ;
//---------------------------------------------------------------------------------------
//  ***  16- CRC  String (1   12 )
//---------------------------------------------------------------------------------------
uint16_t  RT_HW_CONSOLE:: CRC16_String(String &s){ 
 hive.index=s.length();	hive.buff16=0;	
  for (uint8_t j=hive.index; j>0; j--)
   {hive.buff16 ^=hive.buff16+s.charAt(j);
     for (uint8_t i=0; i<8; i++)
      {if (hive.buff16 & 1) {hive.buff16= (hive.buff16 >> 1) ^ 0xA001;} // 0xA001 is the reflection of 0x8005
					   else {hive.buff16 >>= 1;}}}			return hive.buff16;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void 	RT_HW_CONSOLE::printChar  (char val) {if(!hive.ready) return; Serial.write(val);} 						//-- ;
void 	RT_HW_CONSOLE::printEndLine() {if(!hive.ready) return; printChar('\n');};								//-- ;
void 	RT_HW_CONSOLE::printBlank(uint8_t n, char blank){if((blank=='s') || (blank=='S')) blank=' '; for(hive.index=0; hive.index < n; hive.index++){printChar(blank);}}; 			//--   ;
void 	RT_HW_CONSOLE::printLine (uint8_t n, char blank){                                            for(hive.index=0; hive.index < n; hive.index++){printChar(blank);} printEndLine();}; //--   ;
void	RT_HW_CONSOLE::printSuff (char suff){if(suff==RT_HW_CONSOLE_BREAK_CHAR) return;	if(suff=='Y'){printEndLine();return;} printChar(suff);};//-- ;	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	    PROGMEM
//:	len -  ; alig -  (N,L,C,R); blank -  ( 's'  'S',   ;
//		suff  -.  '~',    ;  'Y',    ;
//		:	const char text_1[] 	    PROGMEM = { "tex~t 1" };   	//--      ('~');
//				const char text_2[] 	    PROGMEM = { "text 2" };
//			    const char* const prtText[] PROGMEM = {head_1, head_2};
//      RT_HW_Console.printTextFromPGM(ptrText[0], 10, 'C', '+', 'Y'); //-- "++++tex+++";
//      RT_HW_Console.printTextFromPGM(ptrText[1], 10, 'C', '-', 'Y'); //-- "--text 2--";
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	 
void RT_HW_CONSOLE::printTextFromPGM(uint32_t ptr, uint8_t len, char alig, char blank, char suff) {
/* 
 if(hive.ready){
  hive.buff8=0; do{ hive.buffChar=char(pgm_read_byte(ptr+hive.buff8));				//--       len; 
  if((hive.buffChar=='\0') || (hive.buffChar==RT_HW_CONSOLE_BREAK_CHAR)) break; 	//--  NULL  "" ;  
  if((len!=0) && (hive.buff8 > len)) break; hive.buff8++;} while(1); 				//-- -     len;	
  if((alig=='N') || (len==0) || (blank==RT_HW_CONSOLE_BREAK_CHAR)) len=hive.buff8;	//--      ; 
  //--   --------------------------------------------------------------------	 
  printBlank(getLenBegin(len, hive.buff8, alig), blank);							//--   ;
  for(hive.index=0; hive.index < hive.buff8; hive.index++) {
  printChar(char(pgm_read_byte(ptr+hive.index)));
	  } 	//-- ;	
  printBlank(getLenEnd  (len, hive.buff8, alig), blank);							//--   ;	
  printSuff(suff);}
*/  
  }	  															//--   ;	  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		    (    rintTextFromPGM()  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_CONSOLE::printString (String &s, uint8_t len, char alig, char blank, char suff) { 
  hive.buff8=s.length(); if(hive.buff8>len) hive.buff8=len;							//--   ;		
  if((alig=='N') || (len==0) || (blank==RT_HW_CONSOLE_BREAK_CHAR)) len=hive.buff8;	//--     ;
  //--   --------------------------------------------------------------------	 
  printBlank(getLenBegin(len, hive.buff8, alig), blank);							//--   ; 
  for(hive.index=0; hive.index < hive.buff8; hive.index++) {printChar(s.charAt(hive.index));} //--  ;
  printBlank(getLenEnd  (len, hive.buff8, alig), blank);							//--   ;	
  printSuff(suff);}		

  
bool RT_HW_CONSOLE::checkChangeInt8x4(uint8_t* ago, uint8_t v1, uint8_t v2, uint8_t v3,uint8_t v4){
  if((ago[0]!=v1) || (ago[1]!=v2) || (ago[2]!=v3) || (ago[3]!=v4) ) { ago[0]=v1;  ago[1]=v2;  ago[2]=v3; ago[3]=v4; return 1;} return 0;}; 

void RT_HW_CONSOLE::printInt8x4(RT_HW_CONSOLE_VAL_ID &id, uint8_t* ago, uint8_t qnt){  
for(int8_t i=0; i< 4; i++) {if(i>=qnt) break; setVar_ID(id,'D',0,(int8_t)ago[i]); printVar_ID(id,4,'R' ,'~' );}}; 
//--   ;	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		var_ID:       
// id.mode: =0 -BIN, =1 -DEC, =2 -HEX;
// id.form: =0 - ,=1 -1   ;=2 -2   ;=3 -3   ; 
//			=8 -  uint8_t; =16 -  uint16_t; =32 -  uint32_t; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_CONSOLE:: setVar_ID(RT_HW_CONSOLE_VAL_ID &iv, char mode, uint8_t form, int32_t val){
  if(!iv.len) iv.len=1;  //--  id.len (  1 -  val=0; 
  iv.minus=0;
  iv.point=iv.pnt=0;  //-- ;
  switch(mode){default:			//--      ;
	case 'D': iv.mode=1; if(val<0) {iv.val=-val; iv.minus=1;} else {iv.val=val;}	 		  
			  switch(form){default:
				case  0: iv.point=0; break;	
				case  1: iv.point=1; break;	
				case  2: iv.point=2; break;	
				case  3: iv.point=3; break;			
				case  8: iv.val= (uint8_t)val&0xff;;	iv.minus=iv.point=0;	break;
				case 16: iv.val=(uint16_t)val&0xffff;	iv.minus=iv.point=0;	break; 
				case 32: iv.val=(uint32_t)val;  		iv.minus=iv.point=0;	break;} //--END switch(form);
			  hive.buff32=iv.val;
			  iv.len=0; do{if(iv.len>=iv.point) break; iv.len++; hive.buff32/10;}           while(iv.len<12); //--      ;
              iv.len=0; do{hive.buff32=hive.buff32/10; iv.len++; if(hive.buff32==0) break;} while(iv.len<12); //-- -    ;
			  while(iv.len<=iv.point) {iv.len++;};	
			  if(iv.point) iv.pnt=1; 
			  break;	//-- -  ;																												
    case 'T': iv.len=2;  iv.mode=1; if(val<0) val=-val; if(val<100) iv.val=val; else iv.val=0; iv.len=2;			break;	//-- 2-   ;
    case 'B': iv.len=8;  iv.mode=0; iv.val=val & 0xff;  															break;	//-- 8-  BIN-;	
    case 'b': iv.len=4;  iv.mode=0; iv.val=val & 0x0f; 																break;	//-- 4-   BIN-;	
    case 'H': iv.len=4;  iv.mode=2; iv.val=val & 0xffff; 		 													break;	//-- 4-   HEX-;
    case 'h': iv.len=2;  iv.mode=2; iv.val=val & 0xff; 		 														break;}	//-- 2-   HEX-;	
};  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		var_ID:       
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void	RT_HW_CONSOLE:: printVar_ID(RT_HW_CONSOLE_VAL_ID &iv, uint8_t len, char alig, char suff){
  iv.mess=iv.num=0; iv.index=iv.minus+iv.len+iv.pnt;	  								//--   ;	   
  printBlank(getLenBegin(len,(iv.minus+iv.len+iv.pnt),alig),RT_HW_CONSOLE_BLANK);	//-- ;
  if((len>0) && iv.minus) {printChar('-'); iv.index--; iv.mess++;} 						//--  '-';
 //------------------------------------------------------------------------------------------------
  do{if(iv.index==0) break; if(iv.mess>=len) break;										//-- ;
     iv.num++; printChar(getChar_ID(iv,iv.num)); iv.index--; iv.mess++;
	 if(iv.index==0) break; if(iv.mess>=len) break;
	 if((iv.pnt>0) && ((iv.len-iv.num)==iv.point)) {printChar('.'); iv.index--; iv.mess++;}}while(1);
  printBlank(getLenEnd(len,(iv.minus+iv.len+iv.pnt),alig),RT_HW_CONSOLE_BLANK);	//--    ;	
printSuff(suff);};																		//--   ;	  		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	var_ID:            
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char	RT_HW_CONSOLE:: getChar_ID(RT_HW_CONSOLE_VAL_ID &iv, uint8_t n){
hive.val=iv.val; 
  if(!n || (n>iv.len) || (n>10)) return ' '; n=iv.len-n+1;
  switch(iv.mode){default:
  case 1: hive.buff8=0; hive.buff32=0; 
		  while(iv.val>0) {hive.buff8++; hive.buff32=hive.val-((hive.val/10)*10); if(hive.buff8 >=n) break; hive.val/=10;};	
													break;
  case 0:    hive.buff32=(hive.val>>(n-1))&1;    	break;
  case 2:    hive.buff32=(hive.val>>(n-1)*4)&0xf;	break;}
  if(hive.buff32<=9) {hive.buff32=hive.buff32 +'0';} else {hive.buff32=hive.buff32-10+ (RT_HW_CONSOLE_UPPER ? 'A' : 'a') ;}
return (uint8_t)hive.buff32;};  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void RT_HW_CONSOLE:: PrintTextFromPGM (uint32_t ptr, uint8_t len, char alig, char blank, char suff){printTextFromPGM(ptr, len, alig, blank, suff);};


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	 float  int32_t    -   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int32_t RT_HW_CONSOLE::floatToInt32 (float val, uint8_t point){ for(uint8_t i=1; i< (point+1); i++){val=val*10;}; return round(val);};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	     D(: 0,1,2,3,8,16,32),H,h,B,b,T
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_CONSOLE:: PrintInt32(RT_HW_CONSOLE_EVENT_ID &id, RT_HW_CONSOLE_VAL_ID &iv, uint32_t ptr, int32_t &ago, int32_t val, char mode, uint8_t form, uint8_t ustPeriod, uint8_t len, char alig, char blank, char suff){
  switch(id.dir){default:
	case 0: if(!hive.ready) break; id.period=id.fresh=1; id.cnt=0; id.dir=1; 		//-- ;
	case 1: eventID(id,ustPeriod);  			if(!id.period)  break; id.period=0;	//--   ;
			if(ago!=val) {ago=val; id.fresh=1;} if(!id.fresh)   break; id.fresh=0;	//--   ;
			setVar_ID(iv,mode,form,val); id.dir++;									//--       ;
	case 2: //printTextFromPGM(ptr,0,'N',RT_HW_CONSOLE_BLANK,'~');					//-- ;
			printVar_ID(iv,len,alig,suff);											//-- ;
			id.dir=1; break;}}														//--    ; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	     Float(point 0,1,2,3)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_CONSOLE:: PrintFloat(RT_HW_CONSOLE_EVENT_ID &id, RT_HW_CONSOLE_VAL_ID &iv, uint32_t ptr, float &ago, float val, uint8_t point, uint8_t ustPeriod, uint8_t len, char alig, char blank, char suff){
  switch(id.dir){default:
	case 0: if(!hive.ready) break; id.period=id.fresh=1; id.cnt=0; id.dir=1; 		//-- ;
	case 1: eventID(id,ustPeriod);  			if(!id.period)  break; id.period=0;	//--   ;
			if(ago!=val) {ago=val; id.fresh=1;} if(!id.fresh)   break; id.fresh=0;	//--   ;		
			setVar_ID(iv,'D',point,floatToInt32 (val,point)); id.dir++;				//--       ;
	case 2: //printTextFromPGM(ptr,0,'N',RT_HW_CONSOLE_BLANK,'~');					//-- ;
			printVar_ID(iv,len,alig,suff);											//-- ;
			id.dir=1; break;}}	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_CONSOLE::PrintString (RT_HW_CONSOLE_EVENT_ID &id, String &s, uint16_t &crc16, uint8_t ustPeriod, uint8_t len, char alig, char blank, char suff) { 
switch(id.dir){default:
	case 0: if(!hive.ready) break; id.period=id.fresh=1; id.cnt=0; id.dir=1; 		//-- ;
	case 1: eventID(id,ustPeriod);  			if(!id.period)  break; id.period=0;	//--   ;	
			hive.buff16=CRC16_String(s); 											//--    ;
			if(crc16!=hive.buff16) {crc16=hive.buff16; id.fresh=1;} 				//--  
			if(!id.fresh) break; id.fresh=0; id.dir++;								//      ;
	case 2: printString (s,len,alig,blank,suff);									//-- ;
			id.dir=1; break;}}									//--    ; 

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	    4-  int8_t
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void                 PrintInt8x4(RT_HW_CONSOLE_EVENT_ID &id, RT_HW_CONSOLE_VAL_ID &iv, uint32_t ptr, uint8_t* ago, uint8_t ustPeriod, uint8_t len, char suff, uint8_t qnt, int8_t v1, int8_t v2, int8_t v3, int8_t v4);
void RT_HW_CONSOLE:: PrintInt8x4(RT_HW_CONSOLE_EVENT_ID &id, RT_HW_CONSOLE_VAL_ID &iv, uint32_t ptr, uint8_t* ago, uint8_t ustPeriod, uint8_t len, char suff, uint8_t qnt, uint8_t v1, uint8_t v2, uint8_t v3, uint8_t v4){
  switch(id.dir){default:
	case 0: if(!hive.ready) break; id.period=id.fresh=1; id.cnt=0; id.dir=1; 		//-- ;
	case 1: eventID(id,ustPeriod); if(!id.period)  break; id.period=0;				//--   ;
			if((ago[0]!=v1) || (ago[1]!=v2) || (ago[2]!=v3) || (ago[3]!=v4)) {ago[0]=v1; ago[1]=v2; ago[2]=v3; ago[3]=v4; id.fresh=1;} 
			if(!id.fresh) break; id.fresh=0; id.dir++;								//--   ;
	case 2: //printTextFromPGM(ptr,len,'L',RT_HW_CONSOLE_BLANK,'~');					//-- ;
			printChar(':');															//--  ':';
			for(int8_t i=0; i< 4; i++) {if(i>=qnt) break; setVar_ID(iv,'D',0,(int8_t)ago[i]); printVar_ID(iv,4,'R' ,'~' );}; 
			printSuff(suff);	
			id.dir=1; break;}		
}

			
//------  4- int8------------------------------------------------------------------  

//if(EN) { if(RT_HW_Console.hive.ready)  { 
//  RT_HW_Console.eventDD(dd, ___  ); //--  ;
//  if(dd.first) {dd.first=0; dd.period=dd.run=1;}			    		//--        ;
//  if(dd.period){ if(RT_HW_Console.checkChangeInt8x4(ago,v1,v2,v3,v4)) dd.run=1;}
//  if(dd.run) {dd.run=0; RT_HW_Console.printTextFromPGM(pgm_read_dword(&ptrText[0]),  _ ,'L' , 's' , ':' ); 
//				       RT_HW_Console.printInt8x4(id, ago,  -__  );               
//				       RT_HW_Console.printSuff (  );}}}  run=EN; 
//----------------------------------------------------------------------------------------------------			
			
			
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
RT_HW_CONSOLE  		RT_HW_Console; //-- 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++		
