//======================================================
//    Тест вывода на дисплей в фоновом режиме
//    Библиотека  "RT_HW_LCD_HD44780.h"
//    Адрес дисплея =63(можно поменять), 
//    Адрес контрольного пина->AVR328,MEGA2560,DUE=13; ESP8266,ESP32=2; STM103C=PC13
//    Устойчиво поддерживает горячее переподключение.
//======================================================
#include "RT_HW_LCD_HD44780.h"
//++++++++Выбор параметров под тип контроллера
#if defined (__AVR_ATmega328__) || defined (__AVR_ATmega328P__)  || defined(__AVR_ATmega2560__)  || defined(__AVR_ATmega2561__) || defined(__SAM3X8E__)
  enum {pinControl=13,pinBack=12, pinFast=11};    
#elif defined(ESP8266) || defined(ESP32)
  enum {pinControl=2,pinBack=16, pinFast=14}; 
#elif defined(_VARIANT_ARDUINO_STM32_) 
  enum {pinControl=PA0, pinBack=PA1, pinFast=PA2}; 
#else
  enum {pinControl=13,pinBack=12, pinFast=11};   
#endif  
//==================================================================
RT_HW_LCD_HD44780_DEVICE z1;                            //--Объект - дисплей
RT_HW_LCD_HD44780_DATA_CHAR  str1,str2,chr1,chr2,chr3,chrB;       //--Объект - вывод символов
RT_HW_LCD_HD44780_DATA_INT16 int1,int2,txt1,txt2,sss1,sss2;  //--Объект - вывод int16 с заголовками
RT_HW_LCD_HD44780_DATA_FLOAT flt1,flt2;
//---------------------------
uint8_t  addrLCD=63;              //--адрес дисплея 
char     vCh1='+',vCh2='+',vChB;  //--выводимые символы
int16_t  v1,v2,v3,v4;             //--выводимые на Lcd регистры int
float    f1,f2;                   //--выводимый на Lcd регистр float  
byte    eventBack, eventFast;     //--регистры запуска задач          
bool     blink;                   //--регистр для "мерцания"
uint16_t cntBack,cntFast,clear,cnt1,cnt2,cns1,cns2;; //--регистры для счетчиков
uint32_t timeStart1,timeStart2,timeStart3,timeStart4,timeStart5,timeENs,timeENc,timeENi,timeENf,timeENt,timeENS; //--регистры для таймеров
uint8_t  workStart1,workStart2,workStart3,workStart4,workStart5,workENs,workENc,workENi,workENf,workENt,workENS; //--регистры для таймеров
bool     ENs1,ENs2,ENc1,ENc2,ENcB,ENi1,ENi2,ENf1,ENf2,ENt1,ENt2,ENS1,ENS2;                                       //--разрешения вывода на Lcd
String   arS1[4]={"Hello Word","FLProg","KaScada","EIS_LIB"};
String   arS2[4]={"AVR328","MEGA2560","ESP8266/32","STM32F103C"};
//----------------------------------------------------
void setup() {Serial.begin(115200);
pinMode(pinControl,OUTPUT); pinMode(pinBack,OUTPUT); pinMode(pinFast,OUTPUT); 
ENs1=ENc1=ENcB=ENi1=ENf1=ENt1=ENS1=1;
cntFast=cntBack=cnt1=cnt2=cns1=cns2=0;
clear=0;
}
//----------------------------------------------------
void loop() {
//======Системная часть===============================
blink=!blink; digitalWrite(pinControl,blink); digitalWrite(pinBack,eventBack); digitalWrite(pinFast,eventFast); 
cntBack++; if(cntBack>100) {cntBack=0; eventBack=1;} else  eventBack=0; //--Формирование флага фоновой задачи
cntFast++; if(cntFast>800){cntFast=0;  eventFast=1;} else  eventFast=0;  //--Формирование флага быстрой задачи
//======Быстрая задача=================================
if(eventFast){
//++++ Генерация внешних разрешений вывода на дисплей
//if(RT_HW_Lcd_hd44780.event(timeClear,10000)){clear=!clear;}
//if(!clear){ENi5=EN51=0; ENf1=ENf2=1;
  if(RT_HW_Lcd_hd44780.period(workENs,timeENs, 2500)){ENs1=!ENs1; };                                  
  if(RT_HW_Lcd_hd44780.period(workENc,timeENc, 3000)){ENc1=!ENc1; vCh1='A'; vCh2='h'; cnt1=cnt2=0;}; 
  if(RT_HW_Lcd_hd44780.period(workENi,timeENi, 2000)){ENi1=!ENi1; v1=v2=0;};
  if(RT_HW_Lcd_hd44780.period(workENf,timeENf, 2000)){ENf1=!ENf1; f1=-999; f2=99;};     
  if(RT_HW_Lcd_hd44780.period(workENt,timeENt, 4000)){ENt1=!ENt1;};
  if(RT_HW_Lcd_hd44780.period(workENS,timeENS, 4000)){ENS1=!ENS1; cns1=0; cns2=0; timeStart4=millis();};                       
ENs2=!ENs1; ENc2=!ENc1; ENi2=!ENi1; ENf2=!ENf1; ENt2=!ENt1; ENS2=!ENS1;
//++++ Генерация параметров для вывода на дисплей
if(RT_HW_Lcd_hd44780.period(workStart1,timeStart1, 500)){ vCh1='A'+cnt1; cnt1++; vCh2='h'-cnt2;cnt2++;}
if(RT_HW_Lcd_hd44780.period(workStart2,timeStart2,1000)){ v1=v1+7;     v2=v2+1;}
if(RT_HW_Lcd_hd44780.period(workStart3,timeStart3,1000)){ f1=f1+80.74; f2=f2-10.231;}; 
if(RT_HW_Lcd_hd44780.period(workStart4,timeStart4,1000)){ cns1++; if(cns1>=4) cns1=0;  cns2++; if(cns2>=4) cns2=0;};  
}
//======Фоновая задача================================= 
if(eventBack){
//++++ Блок инициализации и контроля дисплея begin(). Параметры ->lcd,id,col,row,addr;     
switch(z1.dir){default: case 1:break;case 0: Wire.begin(); RT_HW_Lcd_hd44780.device_setID(1,z1,16,2,addrLCD); break; case 2:RT_HW_Lcd_hd44780.begin(z1,clear);break;}
//++++ Блоки мерцания символами. Параметры ->lcd,id,col,row,period,mode='B',signF,signS. Попеременно выводятся символы из буферов id.signF,id.signS.
switch(str1.dir){default: case 1:break; case 0:if(ENs1){RT_HW_Lcd_hd44780.setID_char(1,str1,1,1, -1,'B','*',' ');}  break; case 2:RT_HW_Lcd_hd44780.makeRun_char(str1,ENs1);      RT_HW_Lcd_hd44780.print_char(str1);     break;};  
switch(str2.dir){default: case 1:break; case 0:if(ENs2){RT_HW_Lcd_hd44780.setID_char(1,str2,1,1, -1,'B','|','/');}  break; case 2:RT_HW_Lcd_hd44780.makeRun_char(str2,ENs2);      RT_HW_Lcd_hd44780.print_char(str2);     break;};  
//++++ Блоки вывода символов.    Параметры ->lcd,id,col,row,period,mode='C'.            Выводится входной символ при его изменении.
switch(chr1.dir){default: case 1:break; case 0:if(ENc1){RT_HW_Lcd_hd44780.setID_char(1,chr1,1,2, 2,'C');}           break; case 2:RT_HW_Lcd_hd44780.makeRun_char(chr1,ENc1);       RT_HW_Lcd_hd44780.print_char(chr1,vCh1);break;};
switch(chr2.dir){default: case 1:break; case 0:if(ENc2){RT_HW_Lcd_hd44780.setID_char(1,chr2,1,2, 2,'C');}           break; case 2:RT_HW_Lcd_hd44780.makeRun_char(chr2,ENc2);       RT_HW_Lcd_hd44780.print_char(chr2,vCh2);break;};
//++++ Блок вывода bool в символьной форме. Параметры ->lcd,id,col,row,period,mode='C',signF,signS. При изменении переменной ENs1 выводится: signF, если vChB=0;  signS, если vChB=1;  
switch(chrB.dir){default: case 1:break; case 0:if(ENcB) {RT_HW_Lcd_hd44780.setID_char(1,chrB, 2 ,1 ,2 ,'C','-' ,'+');if(ENs1) vChB=chrB.signS; else vChB=chrB.signF;}break; case 2:RT_HW_Lcd_hd44780.makeRun_bool(chrB,ENcB,ENs1,vChB);RT_HW_Lcd_hd44780.print_char(chrB,vChB );break;};
//++++ Блоки вывода меняющихся int16 с заголовками. Параметры ->lcd,id,col,row,period,aligHead,lenHead,aligVal,lenVal,modeVal,head
switch(int1.dir){default: case 1:break; case 0:if(ENi1){RT_HW_Lcd_hd44780.setID_int16(1,int1,3,1,-1,'L',2,'L',3,'D',"D=");}break;case 2:RT_HW_Lcd_hd44780.makeRun_int16(int1,ENi1);RT_HW_Lcd_hd44780.print_int16(int1,v1);break;};
switch(int2.dir){default: case 1:break; case 0:if(ENi2){RT_HW_Lcd_hd44780.setID_int16(1,int2,3,1,-1,'L',2,'L',2,'h',"h=");}break;case 2:RT_HW_Lcd_hd44780.makeRun_int16(int2,ENi2);RT_HW_Lcd_hd44780.print_int16(int2,v2);break;};
//++++ Блоки вывода меняющихся float с заголовками. Параметры ->lcd,id,col,row,period,aligHead,lenHead,aligVal,lenVal,point,head
switch(flt1.dir){default: case 1:break; case 0:if(ENf1){RT_HW_Lcd_hd44780.setID_float(1,flt1,8,1,-1,'L',2,'L',-1, 2, "F=");}break;case 2:RT_HW_Lcd_hd44780.makeRun_float(flt1,ENf1);RT_HW_Lcd_hd44780.print_float(flt1,f1);break;};
switch(flt2.dir){default: case 1:break; case 0:if(ENf2){RT_HW_Lcd_hd44780.setID_float(1,flt2,8,1,-1,'L',2,'L',-1, 3, "f=");}break;case 2:RT_HW_Lcd_hd44780.makeRun_float(flt2,ENf2);RT_HW_Lcd_hd44780.print_float(flt2,f2);break;};
//++++ Блоки вывода меняющих текстов. Параметры ->lcd,id,col,row,period,aligHead,lenHead,aligVal,lenVal,modeVal,head
switch(txt1.dir){default: case 1:break; case 0:if(ENt1){RT_HW_Lcd_hd44780.setID_int16(1,txt1,2,2,-1,'R',4,'N',0,'N',"ABC");}break;case 2: RT_HW_Lcd_hd44780.makeRun_txt(txt1,ENt1); RT_HW_Lcd_hd44780.print_int16(txt1);break;};
switch(txt2.dir){default: case 1:break; case 0:if(ENt2){RT_HW_Lcd_hd44780.setID_int16(1,txt2,2,2,-1,'R',4,'N',0,'N',"abc");}break;case 2: RT_HW_Lcd_hd44780.makeRun_txt(txt2,ENt2); RT_HW_Lcd_hd44780.print_int16(txt2);break;};
//++++ Блоки вывода меняющих строковых переменных. Параметры ->lcd,id,col,row,period,aligHead,lenHead,aligVal,lenVal,modeVal,head
switch(sss1.dir){default: case 1:break; case 0:if(ENS1){RT_HW_Lcd_hd44780.setID_int16(1,sss1,7,2,2,'C',-1,'N',0,'N',arS1[cns1]);}break; case 2:RT_HW_Lcd_hd44780.makeRun_str(sss1,ENS1,arS1[cns1]); RT_HW_Lcd_hd44780.print_int16(sss1);break;};
switch(sss2.dir){default: case 1:break; case 0:if(ENS2){RT_HW_Lcd_hd44780.setID_int16(1,sss2,7,2,2,'C',-1,'N',0,'N',arS2[cns2]);}break; case 2:RT_HW_Lcd_hd44780.makeRun_str(sss2,ENS2,arS2[cns2]); RT_HW_Lcd_hd44780.print_int16(sss2);break;};
//------------------------------------------------------
} //--END if(eventBack)
//====================================================
} //--END LOOP
