#include "RT_HW_LCD_HD44780.h"
#include "RT_HW_LCD_HD44780_DEFINE.hpp"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
 //#define constrain(amt,low,high) ((amt)<(low)?(low):((amt)>(high)?(high):(amt)))
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			КОНСТРУКТОР
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_LCD_HD44780::RT_HW_LCD_HD44780(){
	device.set=0;						//--Регистр флагов инициализация устройств;
	device.qnt=0;						//--Кол-во зарегистрированных устройств в системе;
	device.i2c_ok=device.spi_ok=false;	//--Флаг инциализации интерфейсов i2c и spi;
//	for(uint8_t i=0; i<RT_HW_LCD_HD44780_MAX_DEVICE;i++) {prt[i]=&nullDevice;}
}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 ГЕНЕРАТОР МЕАНДРА ДЛЯ УПРАВЛЕНИЯ УСТРОЙСТВОМ 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_LCD_HD44780:: genDeviceTick(RT_HW_LCD_HD44780_DEVICE &z){//  z.event.tick=0; 
 if(RT_HW_LCD_HD44780_MILLIS>=z.event.timeStart) {z.event.timeStart=RT_HW_LCD_HD44780_MILLIS+RT_HW_LCD_HD44780_PERIOD_TICK; 
	z.event.cnt++;  z.event.blink=!z.event.blink;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 ГЕНЕРАТОР ПЕРИОДИЧЕСКОГО ПЕРЕЗАПУСКА УСТРОЙСТВА.
//   Вход:	period - период кратный 50мс. 
//   Выход: z.reboot.run. Если period=0, перезапуск не генерится.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
bool	RT_HW_LCD_HD44780:: genDeviceReboot(RT_HW_LCD_HD44780_DEVICE &z, uint16_t period){   
  if(z.reboot.ago!=z.event.blink) {
	 if(period<40) {z.reboot.run=0; return 0;}
     z.reboot.ago =z.event.blink; z.reboot.cnt++; 
	 if(z.reboot.cnt>period)  {z.reboot.cnt=1; z.reboot.run=1; return 1;}}
return 0;};  		 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 ГЕНЕРАТОР РАЗРЕШЕНИЯ ВЫВОДА НА УСТРОЙСТВА ПО ГОТОВНОСТИ УСТРОЙСТВА И ВРЕМЕНИ
//  Выход id.dir:
//			=4 - переход на очистку;
//			=2 - переход на подгтовку данных, далее 3->id.dir переход на вывод
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
void	RT_HW_LCD_HD44780:: genEventDir(RT_HW_LCD_HD44780_DIRECT &id, uint8_t period, bool EN, bool blink){
  if(prt[id.num]->ok.permit==false) {id.fresh=true; id.step=0; return;}				  //--Обработка, если устройство не готово к использованию;
  if(id.agoEN!=EN) {id.agoEN=EN; if(EN==0) {id.cnt=0; id.fresh=1; id.dir=4; return;}} //--Переход на очистку при EN=1->EN=0;
  if(!EN) {id.cnt=id.cntEN=0; id.first=1; return;}									  //--Запрет на работу при EN=0 (ранее будет выполнена очистка dir=3);
  if( EN) {if(id.cntEN++<3)   return;}									  //--Ожидание разрешения на работу при EN=1 в течении 3-тактов;
  //--Обработка при blink=1 - от таймера мерцания bitRead(prt[id.num]->event.cnt,4
  if(blink){id.cnt=1; if(id.ago!=bitRead(prt[id.num]->event.cnt,3)) 
                        {id.ago =bitRead(prt[id.num]->event.cnt,3); id.fresh=1; if(id.ago) id.dir=4; else id.dir=2;} return;}
  //--Обработка при blink=0 - от таймера prt[id.num]->event.blink c периодом =period;
      else {if(id.ago!=prt[id.num]->event.blink) {id.ago =prt[id.num]->event.blink; if(++id.cnt> period)  {id.cnt=1; id.dir=2;}}}
   if(id.first){id.first=0; id.fresh=1; id.dir=2;}	  
}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//    Контроль готовности устройства (возвращает =1, если не готово);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	   
bool	RT_HW_LCD_HD44780:: checkDirect(RT_HW_LCD_HD44780_DIRECT &id){
	if(prt[id.num]->ok.permit && id.permit) return 0;
	id.fresh=true; id.step=0;               return 1;};   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			УСТАНОВКА ПАРАМЕТРОВ LCD С УЧЕТОМ СПОСОБА ПОДКЛЮЧЕНИЯ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_LCD_HD44780:: setID_device (RT_HW_LCD_HD44780_DEVICE &z, int8_t mode, int8_t adr, uint8_t cols, uint8_t rows){int8_t x;
  if(z.ok.custom)  return; 	z.ok.custom=1;	//--Выход, если устройство инициализировано или установка флага "Параметры устройства установлены";
  bitSet(device.set,0);	    z.num=0;		//--Устройство с номером=0 зарезервировано(устройство отсутствует), бит 0 всегда занят;
  z.adr=adr; 								//--i2c: адрес устройства на шине; SPI: адрес пина CS; bus4: номер пина RS LCD; 
  z.mode=mode;
  //---Настройка под тип подключения к LCD
  switch(z.mode){default: z.mode=0;
	  case 0: z.ok.ban=1; break;
	  //----Настройка последовательного вывода через 3 пина 74HC595: z.adr=latch, z.buff[0]-data, z.buff[1]0 -clock;
	  //case 1: if((z.adr<0)         || (z.buff[1]<0)          || (z.buff[1]<0) || 
	  //          (z.adr==z.buff[0]) || (z.buff[0]==z.buff[1]) || (z.buff[1]==z.adr)) {z.ok.ban=1; break;} 
	  //			pinMode(z.adr,OUTPUT);      digitalWrite(z.adr,1);  
	  //			pinMode(z.buff[0],OUTPUT);  digitalWrite(z.buff[0],0);  
	  //			pinMode(z.buff[1],OUTPUT);  digitalWrite(z.buff[1],0); 
	  //		  break;
	  //----Настройка интерфейса i2c; 
	  case 2: if(z.adr<0) {z.ok.ban=1; break;} 
			  for (int i=0; i<=3; i++) {z.buff[i];} z.work=z.val=0;		//--Очистка регистров(используются при работе c i2c);
			  if(!device.i2c_ok) {device.i2c_ok=true; Wire.begin();}	//--Одноразовая настройка i2c;
			  break;
	  //----Настройка интерфейса SPI; 		
	  case 3: if(z.adr<0) {z.ok.ban=1; break;} 
	          pinMode(z.adr,OUTPUT); digitalWrite(z.adr,true);
		      if(!device.spi_ok) {device.spi_ok=true; SPI.begin(); digitalWrite(z.adr,false); SPI.transfer(0); digitalWrite(z.adr,true);}//--Одноразовая настройка SPI;
			  break;
	 //----Настройка прямого управления через 4-х битную шину; 		
	  case 4: z.work=0; for(uint8_t i=0; i<6; i++){if((z.buff[i]==0) || (z.buff[i]<0)) z.work++;} if(z.work>1) {z.ok.ban=1; break;}  
			  for (int i=0;i<6;i++){pinMode(z.buff[i],OUTPUT); digitalWrite(z.buff[i],0);} break; 
	  }				
  //--Получение номера первого свободного бита (он же номер устройства); Установка z.ok.ban если заняты все номерf устройств (от 1 до MAX_DEVICE);  				
  if(!z.ok.ban){x=getFistBitUint16(device.set);	if ((x<0)||(x>RT_HW_LCD_HD44780_MAX_DEVICE)) z.ok.ban=1;} 
  //---1)Установка бита занятости устройства; 2)Присвоение номера устройству; 3)Сохранение указателя ID; 4)Вычисление кол-ва подключенных устройств; 
  if(!z.ok.ban){bitSet(device.set,x); z.num=x;	prt[z.num]=&z; device.qnt++;}	
  //---Установка параметров колонок и столбцов
  z.cols=constrain(cols,1,RT_HW_LCD_HD44780_MAX_COLS);	//--Установка кол-во колонок LCD;  
  z.rows=constrain(rows,1,RT_HW_LCD_HD44780_MAX_ROWS);	//--Установка кол-ва строк   LCD; 
  z.ok.init=z.ok.link=z.ok.permit=false; 				//--Сброс флагов;
  z.qntReboot=120;  									//--Уставка перезапуска 50ms*120=6000ms=60sec;
}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	  НАСТРОЙКА ДЛЯ УПРАВЛЕНИЯ ОБМЕНА С УСТРОЙСТВОМ (возвращает =1 если не готово;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    							  		 
bool RT_HW_LCD_HD44780::setID_direct(RT_HW_LCD_HD44780_DIRECT &id, int8_t num, uint8_t col, uint8_t row, uint8_t len){
  if((num<1)||(num>device.qnt)){id.permit=false; return 1;}//--Ожидание, когда придет допустимый номер устройства;
  id.num=num;													//--Сохранение номера устройства;
  id.col=constrain(col,1,RT_HW_Lcd_hd44780.prt[id.num]->cols);	//--Сохранение номера колонки с ограничением диапазона;
  id.row=constrain(row,1,RT_HW_Lcd_hd44780.prt[id.num]->rows);	//--Сохранение номера строки  с ограничением диапазона;
  id.len=constrain(len,0,(prt[id.num]->cols-id.col+1));			//--Установка длины сообщения (id.col уже ограничено размером LCD);
  id.cnt=id.step=0;												//--Очистка регистров;
  id.permit=id.first=id.start=id.fresh=true;	//--Установка флагов;
  id.dir=1;
  return 0;};   
//=====================================ВЫВОД=======================================================			  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									ОЧИСТКА ПОЛЯ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
bool RT_HW_LCD_HD44780:: printClear(RT_HW_LCD_HD44780_DIRECT &id) {
  if (checkDirect(id)) return 0;														//--Контроль готовности устройства и блока;
  switch (id.step){default: id.step=0;													//--Переход на начало или на программно прерванный шаг;
	case 0: id.run=0; id.out=1; id.step++;      										//--Обработка начала вывода;
	case 1: if(prt[id.num]->ok.busy) break; prt[id.num]->ok.busy=true; id.step++;		//--Захват устройства;	
	case 2: if(send(*prt[id.num],pointCursor(id.col,id.row),CMND,50)) {break;} id.step++;	//--Установка курсора;	
	case 3: id.index=id.len; id.step++;													//--Вывод
	case 4: if(printBlank(id)) break;										 id.step++; //       пробелов;
	case 5: prt[id.num]->ok.busy=false; id.out=0; id.run=true; 	id.step=0;	 
			break; 	//--Обработка завершения вывода;
} 
return id.run;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   							 ВЫВОД СИМВОЛА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_LCD_HD44780:: printChar (RT_HW_LCD_HD44780_DIRECT &id, char val){	
  if (checkDirect(id)) return 0;														//--Контроль готовности устройства и блока;
  switch (id.step){default: id.step=0;													//--Переход на начало или на программно прерванный шаг;
	case 0: printBegin(id);          											    	//--Обработка начала вывода;
	case 1: if(prt[id.num]->ok.busy) break;		   prt[id.num]->ok.busy=true; id.step++;//--Захват устройства;	
	case 2: if(send(*prt[id.num],pointCursor(id.col,id.row),CMND,50))  break; id.step++;//--Установка курсора;	
	case 3: if(send(*prt[id.num],val))								   break; id.step++;//--Вывод символа;
	case 4: printEnd(id);		 break;													//--Обработка завершения вывода;
} return id.run;}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  					ФОРМАТИРОВАННЫЙ ВЫВОД СТРОКОВОЙ ПЕРЕМЕННОЙ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	 
bool RT_HW_LCD_HD44780:: printString(RT_HW_LCD_HD44780_DIRECT &id, String &str, char alig) {
  if (checkDirect(id)) return 0;														//--Контроль готовности устройства и блока;
  switch (id.step){default: id.step=0;													//--Переход на начало или на программно прерванный шаг;
    case 0: printBegin(id); 															//--Обработка начала вывода;
	case 1: id.sz=getLenString(id,str);	id.step++; 										//--Установка длины выводимой переменной;
	case 2: if(prt[id.num]->ok.busy) break;		 prt[id.num]->ok.busy=true; id.step++;	//--Захват устройства;	
	case 3: if(send(*prt[id.num],pointCursor(id.col,id.row),CMND,50)){break;} id.step++;	//--Установка курсора;	
	case 4: id.index=getLenBegin(id.len,id.sz,alig);                     	id.step++;	//--Вывод пробелов
	case 5: if(printBlank(id))	break;  									id.step++;	// 		перед переменной;
	case 6: id.index=0;  id.step++; 													//--Вывод  
	case 7: if(id.index<id.sz) {if(send(*prt[id.num],str.charAt(id.index))) break; id.index++; break;} id.step++;	//--Вывод переменной
	case 8: id.index=getLenEnd(id.len,id.sz,alig); 							id.step++;	//--Вывод пробелов
	case 9: if(printBlank(id))	break; 										id.step++;	// 		перед переменной;
	case 10: printEnd(id);		break;													//--Обработка завершения вывода;
} return id.run;}; //-Завершение;//--END 	  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  						ФОРМАТИРОВАННЫЙ ВЫВОД ПЕРЕМЕННОЙ
//getLenString(RT_HW_LCD_HD44780_DIRECT &id, String &str)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	 
bool 	 RT_HW_LCD_HD44780:: printVal(RT_HW_LCD_HD44780_DIRECT &id, RT_HW_LCD_HD44780_VAL_ID &iv, String &head, char suff, char alig) {
  if (checkDirect(id)) return 0;	//--Контроль готовности устройства и блока;
  switch (id.step){default:id.step=0; 													//--Переход на начало или на программно прерванный шаг;
    case 0: printBegin(id); 															//--Обработка начала вывода;
	case 1: id.head=constrain(getLenString(id, head),0,id.len);								//--Получение длины заголовка;
			if((suff!=RT_HW_LCD_HD44780_BREAK_CHAR) && (id.len>id.head)) id.end=1;		//--Получение длины суффикса;
			while ((iv.len>0) && (iv.len>id.len)) {iv.len--;}							//--Ограничение длины значения длиной поля;
			if((iv.minus+iv.len+iv.pnt)>id.len) iv.pnt=0;								//--Ограничение длины отбрасыванием точки; 
			if((iv.minus+iv.len+iv.pnt)>id.len) iv.minus=0;								//--Ограничение длины отбрасыванием минуса;
			id.sz=iv.minus+iv.len+iv.pnt;												//--Расчет нормируемой длины значения;
			if((id.sz+id.head+id.end)>id.len) id.end=0;									//--Ограничение длины отбрасыванием суффикса;
			while ((id.head>0) && ((id.sz+id.head)>id.len)) {id.head--;}				//--Ограничение длины обрезанием спереди заголовка;
			id.sz  =constrain(id.sz,0,(id.len-id.head-id.end)); 						//--Получение длины значения;
			id.step++; 																	//--Переход на захват устройства;
	case 2: if(prt[id.num]->ok.busy) break; 	prt[id.num]->ok.busy=true; 	id.step++;	//--Захват устройства;	
	case 3: if(send(*prt[id.num],pointCursor(id.col,id.row),CMND,50)) break;id.step++;	//--Установка курсора;	
	case 4: id.index=0; id.step++; 														//--Вывод заголовка;	
	case 5: if(id.index<id.head){if(send(*prt[id.num],head.charAt(id.index))) break; id.index++; break;} id.step++;	
	case 6: id.index=getLenBegin((id.len-id.head-id.end),id.sz,alig); 		id.step++;  //--Вывод заполнителей
	case 7: if(printBlank(id)) break; 										id.step++;	//       перед переменной;
	case 8: if(id.sz){if(iv.minus) {if(send(*prt[id.num],'-')) break;}} 	id.step++;	//--Вывод минуса (если он есть);		
	case 9: iv.num=1; id.step++; 														//--Подготовка счетчика выведенных цифр;
	case 10:if((iv.num<=iv.len)&& ((iv.pnt>0)&&((iv.len+1-iv.num)!=iv.point)))			//--Вывод   значения
			{if(send(*prt[id.num],getChar_ID(iv,iv.num))) break; iv.num++; break;}; id.step++; // до точки;
	case 11:if(iv.pnt){if(send(*prt[id.num],'.')) break; id.step++; break;} id.step++;		//--Вывод точки------
	case 12:if(iv.num<=iv.len){if(send(*prt[id.num],getChar_ID(iv,iv.num))) break; iv.num++; break;} id.step++;	//--Вывод значения после точки			 
	case 13:if(id.end){if(send(*prt[id.num],suff)) break;} 					id.step++;	//--Вывод суффикса;
	case 14:id.index=getLenEnd((id.len-id.head-id.end),id.sz,alig); 		id.step++;	//--Вывод заполнителей 
	case 15:if(printBlank(id))	break; 										id.step++;	//       после переменной;								
	case 16: printEnd(id);		break;													//--Обработка завершения вывода;
} return id.run;}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    Функция начала вывода(=1 прекратить вывод)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_LCD_HD44780:: printBegin(RT_HW_LCD_HD44780_DIRECT &id){if(id.fresh) {id.run=0; id.fresh=0; id.out=1; id.step++;} else {id.run=true;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    Функция завершения вывода (=0 вывод завершен)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_LCD_HD44780:: printEnd(RT_HW_LCD_HD44780_DIRECT &id){prt[id.num]->ok.busy=false; id.out=0; id.run=true; id.step=0;} 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Получение длины строковой переменной из PROGMEM (=1 - вывод не завершен)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool	RT_HW_LCD_HD44780:: printBlank(RT_HW_LCD_HD44780_DIRECT &id){
	if(id.index>0) {if(send(*prt[id.num],RT_HW_LCD_HD44780_BLANK)) return 1; id.index--; if(id.index) return 1;} return 0;}

//================================ВЫВОД ЧЕРЕЗ БЛОКИ FLPROG=========================================	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  								ВЫВОД ЧЕРЕЗ БЛОК CHAR
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void 	RT_HW_LCD_HD44780:: PrintChar(RT_HW_LCD_HD44780_DIRECT &id, uint8_t col, uint8_t row, uint8_t period, uint8_t lcd, bool EN, bool blink, char val){
  switch(id.dir){
	case 0: if(setID_direct(id,lcd,col,row)) break;		id.dir=1;
	case 1:	genEventDir(id,period,EN,blink); break;
	case 2:	if(id.buff !=val) {id.buff=val;id.fresh=1;} 
			if(id.fresh) {id.dir++;}              else {id.dir=1; break;}
	case 3: if(printChar(id,id.buff)) 					id.dir=1; break; 
    case 4: if(printChar(id,RT_HW_LCD_HD44780_BLANK))	id.dir=1; break;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  								ВЫВОД ЧЕРЕЗ БЛОК BOOL
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void 	RT_HW_LCD_HD44780:: PrintBool(RT_HW_LCD_HD44780_DIRECT &id, uint8_t col, uint8_t row, uint8_t period, uint8_t lcd, bool EN, bool blink, bool val, char sign0, char sign1){
  switch(id.dir){
	case 0: setID_direct(id,lcd,col,row);	 break;		 
	case 1:	genEventDir(id,period,EN,blink); break;
	case 2:	if(id.agoBool !=val) {id.agoBool=val; id.fresh=1;} 
	        if(id.fresh) {id.buff=boolToChar(id.agoBool,sign0,sign1); id.dir++;} 
					else 							   {id.dir=1; break;} 
	case 3: if(printChar(id,id.buff)) 					id.dir=1; break; 
    case 4: if(printChar(id,RT_HW_LCD_HD44780_BLANK))	id.dir=1; break;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  								ВЫВОД ЧЕРЕЗ БЛОК BLINK
// EN - внешний сигнал разрешения;
// blink - мерцание символа (в блоке=0);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void 	RT_HW_LCD_HD44780:: PrintBlink(RT_HW_LCD_HD44780_DIRECT &id,
                            uint8_t col, uint8_t row, uint8_t period, uint8_t lcd, bool EN, char sign0, char sign1){
  switch(id.dir){
	case 0: setID_direct(id,lcd,col,row);	 break;   
	case 1:	genEventDir(id,period,EN,0); 	 break;
	case 2:	id.agoBool =!id.agoBool; id.fresh=1; id.buff=boolToChar(id.agoBool,sign0,sign1); id.dir++; 
	case 3: if(printChar(id,id.buff)) 					id.dir=1; break; 
    case 4: if(printChar(id,RT_HW_LCD_HD44780_BLANK))   id.dir=1; break;}}; 	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  								ВЫВОД ЧЕРЕЗ БЛОК переменной DEC(0,1,2,3,8,16,32),HEX,BIN,T
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void 	RT_HW_LCD_HD44780:: PrintVal(RT_HW_LCD_HD44780_DIRECT &id,RT_HW_LCD_HD44780_VAL_ID &iv,int32_t &ago,  String &head, char alig, uint8_t len,
							uint8_t col, uint8_t row, uint8_t period, uint8_t lcd, bool EN, bool blink, int32_t val,char mode, uint8_t form, char suff ){	
  switch(id.dir){
	case 0: setID_direct(id,lcd,col,row,len); break; 
	case 1: genEventDir(id,period,EN,blink);  break;
	case 2:	if(ago!=val) {ago=val; id.fresh=1;}
			if(!id.fresh) {id.dir=1; break;}
			setVar_ID(iv, mode, form, val);    id.dir=3;	
	case 3: if(printVal(id,iv,head,suff,alig)) id.dir=1; break;
	case 4: if(printClear(id))   			   id.dir=1; break;};};		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  								ВЫВОД ЧЕРЕЗ БЛОК переменной float
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void 	RT_HW_LCD_HD44780:: PrintFloat(RT_HW_LCD_HD44780_DIRECT &id, RT_HW_LCD_HD44780_VAL_ID &iv, float &ago,  String &head, char alig, uint8_t len, 
							uint8_t col, uint8_t row, uint8_t period, uint8_t lcd, bool EN, bool blink, float val, uint8_t point, char suff){	
  switch(id.dir){
	case 0: setID_direct(id,lcd,col,row,len); break;
	case 1: genEventDir(id,period,EN,blink);  break;
	case 2:	if(ago!=val) {ago=val; id.fresh=1;}
			if(!id.fresh) {id.dir=1; break;}
			setVar_ID(iv,'D', point, floatToInt32 (val, point));   id.dir=3;	
	case 3: if(printVal(id,iv,head,suff,alig)) id.dir=1; break;
	case 4: if(printClear(id))   			  id.dir=1; break;};	
	};			
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  								ВЫВОД ЧЕРЕЗ БЛОК СТРОКОВОЙ ПЕРЕМЕННОЙ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
void 	RT_HW_LCD_HD44780:: PrintString(RT_HW_LCD_HD44780_DIRECT &id, uint16_t &crc16, char alig, uint8_t len,     
                            uint8_t col, uint8_t row, uint8_t period, uint8_t lcd, bool EN, bool blink, String &str){
  switch(id.dir){
	case 0: setID_direct(id,lcd,col,row,len);    				  break; 
	case 1:	genEventDir(id,period,EN,blink); 					  break;
	case 2:	hive.buff16=CRC16_String(str); if(crc16!=hive.buff16) {crc16=hive.buff16; id.fresh=1;} 
	        if(id.fresh) id.dir++; 			  	  else {id.dir=1; break;} 
	case 3: if(printString(id,str,alig)) 				id.dir=1; break; 
    case 4: if(printClear(id))   						id.dir=1; break;}}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  								ВЫВОД ЧЕРЕЗ БЛОК ТЕКСТОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
void 	RT_HW_LCD_HD44780:: PrintTxt(RT_HW_LCD_HD44780_DIRECT &id, char alig, uint8_t len,                                                    
							uint8_t col, uint8_t row, uint8_t period, uint8_t lcd, bool EN, bool blink, String &str){
  switch(id.dir){
	case 0: setID_direct(id,lcd,col,row,len);    				  break; 
	case 1:	genEventDir(id,period,EN,blink); 					  break;
	case 2:	if(id.fresh) id.dir++; 				  else {id.dir=1; break;} 
	case 3: if(printString(id,str,alig)) 				id.dir=1; break; 
	case 4: if(printClear(id))   						id.dir=1; break;}};   		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Форматированный вывод строковой переменной
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_LCD_HD44780:: getLenString(RT_HW_LCD_HD44780_DIRECT &id, String &str){
  id.index=0; do{if(id.index>=id.len) break; id.buff=str.charAt(id.index);	//--Получение размера выводимого текста с ограничением параметром len; 
  if((id.buff=='\0') || (id.buff==RT_HW_LCD_HD44780_BREAK_CHAR)) break;		//--Поиск до NULL или "Блокирующего" символа;  
  id.index++;} while(1); return id.index;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
//                **** ВОЗВРАЩАЕТ АДРЕС ПОЗИЦИИ ПО НОМЕРУ КОЛОНКИ И НОМЕРУ СТРОКИ 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
uint8_t  RT_HW_LCD_HD44780::  pointCursor(uint8_t col, uint8_t row) {row=constrain(row,1,4);
switch(row-1){case 0: return (0x80 | ((col-1) + 0x00)); 
              case 1: return (0x80 | ((col-1) + 0x40)); 
			  case 2: return (0x80 | ((col-1) + 0x14));
			  case 3: return (0x80 | ((col-1) + 0x54));}}  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
//    ВОЗВРАЩАЕТ КОЛ-ВО СИМВОЛОВ ДОБАВЛЯЕМЫХ ДО ФОРМАТИРУЕМОЙ СТРОКИ  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_LCD_HD44780:: getLenBegin(uint8_t len,uint8_t src,char alig){
if(len<=src)  {return 0;}   
if(alig=='C') {return (len-src-(len-src)/2);} 
if(alig=='R') {return (len-src);} return 0;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
//    ВОЗВРАЩАЕТ КОЛ-ВО СИМВОЛОВ ДОБАВЛЯЕМЫХ ПОСЛЕ ФОРМАТИРУЕМОЙ СТРОКИ  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
uint8_t RT_HW_LCD_HD44780:: getLenEnd  (uint8_t len,uint8_t src,char alig){
if(len<=src)  {return 0;} 
if(alig=='C') {return (len-(len-src-(len-src)/2)-src);} 
if(alig=='L') {return (len-src);} return 0;} 	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Конвертор bool в char
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char    RT_HW_LCD_HD44780::boolToChar (bool val, char sign_0, char sign_1){if(val) return sign_1; else return sign_0;};	//--Конвертация bool в char; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Конвертор float в int32_t су умножением на кол-во знаков после точек
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int32_t RT_HW_LCD_HD44780::floatToInt32 (float val, uint8_t point){ for(uint8_t i=1; i< (point+1); i++){val=val*10;}; return round(val);};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 ВОЗВРАЩАЕТ ПЕРВЫЙ СВОБОДНЫЙ БИТ(=0) В 16-РАЗРЯДНОМ РЕГИСТРЕ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t RT_HW_LCD_HD44780:: getFistBitUint16(uint16_t &reg){for(uint8_t i=0;i<=15;i++) {if(!bitRead(reg,i)) return i;} return -1;};				
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//  Вычисление 16-битной CRC переменной String (1 символ приерно 12 мкс)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t  RT_HW_LCD_HD44780:: CRC16_String(String &s){ 
 hive.index=s.length();	hive.buff16=0;	
  for (uint8_t j=hive.index; j>0; j--)
   {hive.buff16 ^=hive.buff16+s.charAt(j);
     for (uint8_t i=0; i<8; i++)
      {if (hive.buff16 & 1) {hive.buff16= (hive.buff16 >> 1) ^ 0xA001;} // 0xA001 is the reflection of 0x8005
					   else {hive.buff16 >>= 1;}}}			return hive.buff16;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		var_ID: Установка параметров для вывода численной переменной 
// id.mode: =0 -BIN, =1 -DEC, =2 -HEX;
// id.form: =0 -без изменения,=1 -1 знак после точки;=2 -2 знака после точки;=3 -3 знака после точки; 
//			=8 -преобразование в uint8_t; =16 -преобразование в uint16_t; =32 -преобразование в uint32_t; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_LCD_HD44780:: setVar_ID(RT_HW_LCD_HD44780_VAL_ID &iv, char mode, uint8_t form, int32_t val){
  if(!iv.len) iv.len=1;  //--Предварительная установка id.len (для исключения неточностей1 -ситуации с val=0; 
  iv.minus=0;
  iv.point=iv.pnt=0;  //--Очистка переменных;
  switch(mode){default:			//--Настройка параметров в зависимости от типа переменной;
	case 'D': iv.mode=1; if(val<0) {iv.val=-val; iv.minus=1;} else {iv.val=val;}	 		  
			  switch(form){default:
				case  0: iv.point=0; break;	
				case  1: iv.point=1; break;	
				case  2: iv.point=2; break;	
				case  3: iv.point=3; break;			
				case  8: iv.val= (uint8_t)val&0xff;;	iv.minus=iv.point=0;	break;
				case 16: iv.val=(uint16_t)val&0xffff;	iv.minus=iv.point=0;	break; 
				case 32: iv.val=(uint32_t)val;  		iv.minus=iv.point=0;	break;} //--END switch(form);
			  hive.buff32=iv.val;
			  iv.len=0; do{if(iv.len>=iv.point) break; iv.len++; hive.buff32/10;}           while(iv.len<12); //--Выделение в рабочий регистр целой части числа;
              iv.len=0; do{hive.buff32=hive.buff32/10; iv.len++; if(hive.buff32==0) break;} while(iv.len<12); //--Вычисление кол-ва значащих цифр в переменной;
			  while(iv.len<=iv.point) {iv.len++;};	
			  if(iv.point) iv.pnt=1; 
			  break;	//--Получение кол-ва значащих цифр;																												
    case 'T': iv.len=2;  iv.mode=1; if(val<0) val=-val; if(val<100)iv.val=val; else iv.val=0; iv.len=2; break;	//--Формат 2-х  значного времени;
    case 'B': iv.len=8;  iv.mode=0; iv.val=val & 0xff;  												break;	//--Формат 8-ми значного BIN-числа;	
    case 'b': iv.len=4;  iv.mode=0; iv.val=val & 0x0f; 													break;	//--Формат 4-х  значного BIN-числа;	
    case 'H': iv.len=4;  iv.mode=2; iv.val=val & 0xffff; 		 										break;	//--Формат 4-х  значного HEX-числа;
    case 'h': iv.len=2;  iv.mode=2; iv.val=val & 0xff; 		 											break;}	//--Формат 2-х  значного HEX-числа;	
};  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	var_ID: Возвращает цифру в символьной форме из выводимой переменной начиная со старшей позиции
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char	RT_HW_LCD_HD44780:: getChar_ID(RT_HW_LCD_HD44780_VAL_ID &iv, uint8_t n){
hive.val=iv.val; 
  if(!n || (n>iv.len) || (n>10)) return ' '; n=iv.len-n+1;
  switch(iv.mode){default:
  case 1: hive.buff8=0; hive.buff32=0; 
		  while(iv.val>0) {hive.buff8++; hive.buff32=hive.val-((hive.val/10)*10); if(hive.buff8 >=n) break; hive.val/=10;};	
													break;
  case 0:    hive.buff32=(hive.val>>(n-1))&1;    	break;
  case 2:    hive.buff32=(hive.val>>(n-1)*4)&0xf;	break;}
  if(hive.buff32<=9) {hive.buff32=hive.buff32 +'0';} else {hive.buff32=hive.buff32-10+ (RT_HW_LCD_HD44780_UPPER ? 'A' : 'a') ;}
return (uint8_t)hive.buff32;};  
//=================================================================================================	
RT_HW_LCD_HD44780 RT_HW_Lcd_hd44780; //--Создание объекта LCD типа HD44780
//=================================================================================================