
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     МАКРОСЫ ДЛЯ РАБОТЫ С LCD
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define LCD_BEGIN_PERIOD_EVENT				50  	//--Период событий (тики) в ms, генерируемых блоком begin() (для использования отсчета времени в блоках выдачи)
#define LCD_PERIOD_TIC_DEFAULT				25  	//--Полупериод таймера синхронизации (период =50ms);
#define DEVICE_I2C_DELAY_RESTART_SHORT		50  	//--Пауза(мс)  для контрольной проверки наличия устройства
#define DEVICE_I2C_DELAY_RESTART_MIDDLE		100   	//--Пауза(мс)  межу попытками рестарта устройства при поиске
#define DEVICE_I2C_DELAY_RESTART_LONG		1000	//--Пауза(мс)  между поиском устройства, если устройства потеряно
#define DEVICE_I2C_QNT_RESTART				4   	//--Кол-во попыток рестарта устройства, если после сбоя связи
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		КОДЫ КОМАНД НАСТРОЙКИ LCD
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum{BACKLIGHT_ON	=0x08,	BACKLIGHT_OFF	=0x00, //вкл/выкл подсветкой Lcd 
	 CLEAR_DISPLAY	=0x01,	RETURN_HOME		=0x02,	//очистка дисплея (время 1,5мс), перемещает курсор в левую верхнюю позицию  
	 ENTRY_SET		=0x04,	CONTROL_SET		=0x08,	//направ.сдвига курсора и разреш.сдвига дисплея,команда включения курсора и его типа (вкл. дисплея здесь не используется)
	 SHIFT_SET		=0x10,	FUNCTION_SET	=0x20,	//команда сдвига дисплея или курсора, команда модификации дисплея	 
	 SET_CGRAM_ADDR	=0x40,	SET_DDRAM_ADDR	=0x80};	//установка адреса Flash, установка адреса данных RAM
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		ФЛАГИ ДЛЯ КОМАНДЫ ENTRY_MODE_SET
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	 
enum{//--ФЛАГИ ДЛЯ КОМАНДЫ ------------------------------------------------
	 ENTRY_CURSOR_RIGHT=0x00,	ENTRY_CURSOR_LEFT	=0x02,	//направление сдвига курсора вправо/влево
	 ENTRY_DISPLAY_ON  =0x01,	ENTRY_DISPLAY_OFF	=0x00, 	//разрешения/запрет сдвига дисплея
	 //--ФЛАГИ ДЛЯ КОМАНДЫ ДЛЯ DISPLAY_CONTROL-------------------------------------------
	 CONTROL_DISPLAY_ON=0x04,	CONTROL_DISPLAY_OFF	=0x00,	//включение/выключение дисплея
	 CONTROL_CURSOR_ON =0x02,	CONTROL_CURSOR_OFF	=0x00,	//включение/выключения курсора
     CONTROL_BLINK_ON  =0x01,	CONTROL_BLINK_OFF	=0x00,	//мерцающий блок/подчеркивание
	 //--ФЛАГИ ДЛЯ КОМАНДЫ ДЛЯ SHIFT_CURSOR_DISPLAY---------------------------------------
     SHIFT_DISPLAY_MOVE=0x08,	SHIFT_CURSOR_MOVE	=0x00,	//сдвиг дисплея или курсора
     SHIFT_MOVE_RIGHT  =0x04,	SHIFT_MOVE_LEFT		=0x00,	//направление сдвига(дисплея или курсора) 
     //--ФЛАГИ ДЛЯ КОМАНДЫ ДЛЯ FUNCTION_SET (набор функций)-------------------------------
 	 FUNCTION_MODE8	   =0x10,	FUNCTION_MODE4		=0x00,	//8-ми или 4-х разрядный интерфейс
	 FUNCTION_LINE2    =0x08,	FUNCTION_LINE1		=0x00,	//кол-во линий в дисплее
     FUNCTION_DOTS5x10 =0x04,	FUNCTION_DOTS5x8	=0x00,	//размер символа
     //--ФЛАГИ ДЛЯ ОБМЕНА ТЕТРАДАМИ
     FL_EN=B00000100,           FL_RW=B00000010,   FL_RS=B00000001,	
	 //--ФЛАГИ ПРИЗНАКОВ КОМАНДА/ДАННЫЕ
	// FL_CMND=0,                FL_DATA=1
	 };	 

//_RT_HW_INT8_PGM(RT_HW_PINS_ALL)			={22,   0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21};
	 
//static char rus_letters[] = {'А','а','Б','б','В','в','Г','г','Д','д','Е','е','Ж','ж','З','з','И','и','Й','й','К','к','Л','л','М','м','Н','н','О','о','П','п','Р','р','С','с','Т','т','У','у','Ф','ф','Х','х','Ц','ц','Ч','ч','Ш','ш','Щ','щ','Ъ','ъ','Ы','ы','Ь','ь','Э','э','Ю','ю','Я','я'};
//  static char trans_letters[] = {'A','a','\xA0','\xB2','B','\xB3','\xA1','\xB4','\xE0','\xE3','E','e','\xA3','\xB6','\xA4','\xB7','\xA5','\xB8','\xA6','\xB9','K','\xBA','\xA7','\xBB','M','\xBC','H','\xBD','O','o','\xA8','\xBE','P','p','C','c','T','\xBF','\xA9','y','\xAA','\xE4','X','x','\xE1','\xE5','\xAB','\xC0','\xAC','\xC1','\xE2','\xE6','\xAD','\xC2','\xAE','\xC3','b','\xC4','\xAF','\xC5','\xB0','\xC6','\xB1','\xC7'};
//  int lcount = sizeof(rus_letters)/sizeof(char), i, j;
//  for( i=0; i<strlen(str); i++ ) { 
//    if( (byte(str[i]) == 208 and byte(str[i+1]) != 208) or (byte(str[i]) == 209 and byte(str[i+1]) != 209)) continue; // 208 209 игнор, первый байт UTF8
 //   bool found = false;
 //   for(j=0; j < lcount; j++) if( byte(str[i]) == byte(rus_letters[j]) ) {lcd.write(trans_letters[j]); found = true; break;} 
 //   if (!found) lcd.write(str[i]);
 // }
//}
//
//void print_rus(int x, int y, char *str) { // процедура вывода русских букв
//  lcd.setCursor(x, y);
//  print_rus(str);
//}
	 
	 
	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		СПРАВКА ПО УПРАВЛЯЮЩИМ КОДАМ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	 
// B0010 1000  FUNCTION_SET | FUNCTION_MODE4     | FUNCTION_LINE2     | FUNCTION_DOTS5x8 	//--Обмен по 4-х разрядной шине, 2-линии, символ 5х8.     
// B0010 1010  FUNCTION_SET | FUNCTION_MODE8     | FUNCTION_LINE2     | FUNCTION_DOTS5x8 	//--Обмен по 4-х разрядной шине, 2-линии, символ 5х8.   
// B0001 0000  SHIFT_SET    | SHIFT_CURSOR_MOVE  | SHIFT_MOVE_LEFT 							//--Сдвиг курсора, перемещения курсора влево
// B0000 1100  CONTROL_SET  | CONTROL_DISPLAY_ON | CONTROL_CURSOR_OFF | CONTROL_BLINK_OFF	//--Включение дисплея, выключение курсора, тип курсора "мерцание"
// B0000 0110  ENTRY_SET    | ENTRY_CURSOR_LEFT  | ENTRY_DISPLAY_OFF						//--Движение курсора влево, выключение дисплея
// B0001 0001  CLEAR_DISPLAY																//--Очистка дисплея 		 

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		ИНИЦИАЛИЗАЦИЯ И УПРАВЛЕНИЕ УСТРОЙСТВОМ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_LCD_HD44780:: direct(RT_HW_LCD_HD44780_DEVICE &z, uint16_t periodReboot){
  genDeviceTick(z);	//--Генератор устройства - генерит периоды кратные 50мс;
  switch(z.step.direct){default: z.step.direct=0;
	//------Настройка параметров устройства---------------------------------------------
	case 0: if(!z.ok.custom) break;				//--Ожидание настройки параметров устройства;
			if(z.ok.ban)     break;   			//--Если устройство не может быть использовано;
			z.timeDelay=RT_HW_LCD_HD44780_MILLIS;
			z.step.direct++;	
	case 1:	if(((RT_HW_LCD_HD44780_MILLIS-z.timeDelay)>50)) z.step.direct++; break; //--Задержка 50мс для нормализации питания устройства			
	//------Начало автомата управления устройством---------------------------------------
	case 2: z.ok.permit=false;;					//--Запрет на вывод в устройство данных ->работает только настройка; 	
			z.reboot.run=false; z.reboot.cnt=0;	//--Сброс параметров перезагрузки;	
			z.ok.busy=true;						//--Захват шины обмена с устройством для настройки устройства ;
			z.step.init=z.step.send=z.step.sendExtra=0;
			z.find.step=z.find.cnt=0;			//--Очистка регистров;
			z.step.direct++;					//--Переход на поиск устройств;	
	//------Поиск устройства на шине i2c ------------------------------------------------
	case 3: if(z.mode==2) {if(!i2c_find(z.find.step, z.find.cnt, z.find.period, z.timeDelay, z.adr, 20)) break;} z.step.direct++; 
	//------Инициализация устройства-----------------------------------------------------
	case 4: init(z);							//--Вызов программы инициализации;		
			if(!z.ok.link){z.step.direct=2; break;}	//--Если потеряна связь, переход повторный поисл;
			if(!z.ok.init)	 		break;		//--Ожидание завершения инициализации;
			z.ok.busy=false; z.ok.permit=true;	//--Освобождение линии; Установка флага разрешение работы устройства; 
			z.step.direct++; 
	//------Рабочий режим---------------------------------------------------------------		
	case 5: if(!z.ok.link)	  {z.step.direct=2; z.ok.permit=0;   break;}	//Переход, если взведен флаг "Потеря связи";
			if(genDeviceReboot(z, z.qntReboot)){z.step.direct=2; break;};	
			break;
}}; // END direct(RT_HW_LCD_HD44780_DEVICE &z)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  ПОИСК УСТРОЙСТВА НА ШИНЕ i2c 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_LCD_HD44780:: i2c_find(uint8_t &step, uint8_t &cnt, uint16_t &period, uint32_t &timeDelay,  int8_t adr, uint8_t cntMax){
switch(step){default: step=0;   
  case 0: if(adr<0)	return 0;; 										//--Выход, если не допустимый адрес;
		cnt=0; period=0; timeDelay=RT_HW_LCD_HD44780_MILLIS; step++;//--Сброс параметров, запоминаем время, переход;
  case 1: if(!((RT_HW_LCD_HD44780_MILLIS-timeDelay)>period)) return 0; timeDelay=RT_HW_LCD_HD44780_MILLIS; //--Ожидание задержки по времени;
		  cnt++; if(cnt>=cntMax) cnt=cntMax; 						//--Ограничение счетчика сверху;
		  Wire.beginTransmission(adr);								//--Запрос на шину i2c
			if(Wire.endTransmission()==0){ 							//		 и проверка кода ответа (=0 - устройство ответило);
			if(cnt <2) {period=50;			return 0;}				//--Выход для повторного поиска (для надежности) или успешное завершение;
			if(cnt==2) {step=0; 			return 1;}				//--
			if(cnt >2) {period=50;   cnt=1; return 0;}}				//--Успешное завершение;
		  period =100*cnt;					return 0;}};			//--Выход для повторного поиска;	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		ИНИЦИАЛИЗАЦИЯ ШИНЫ LCD
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_LCD_HD44780:: init(RT_HW_LCD_HD44780_DEVICE &z) {
switch(z.step.init) {default: z.step.init=0;	
  case 0: z.ok.init=0; z.ok.link=1; z.timeDelay=RT_HW_LCD_HD44780_MICROS; z.step.init++;
  case 1: if((RT_HW_LCD_HD44780_MICROS-z.timeDelay)<5000)  break;  z.step.init++;
  case 2: if(send(z,B00000011,CMND,4500,1)) break; z.step.init++;	//--передача тетрады
  case 3: if(send(z,B00000011,CMND,4500,1))	break; z.step.init++;	//--передача тетрады
  case 4: if(send(z,B00000011,CMND,4500,1)) break; z.step.init++;	//--передача тетрады
  case 5: if(send(z,B00000010,CMND,2000,1))	break; z.step.init++;	//--передача тетрады
  case 6: if(send(z,B00100000,CMND,2000,0))	break; z.step.init++;	//--NF	
  case 7: if(send(z,B00000001,CMND,2000,0))	break; z.step.init++;
  case 8: if(send(z,B00000100,CMND,2000,0))	break; z.step.init++;
  //------------------------------------------------------------------------------	 
  case 9: if(send(z,B00101000,CMND,2000,0))	break; z.step.init++;	//--Обмен по 4-х разрядной шине, 2-линии, символ 5х8.           					
  case 10:if(send(z,B00010000,CMND,2000,0))	break; z.step.init++;	//--Сдвиг курсора, перемещения курсора влево
  case 11:if(send(z,B00001100,CMND,2000,0)) break; z.step.init++;	//--Включение дисплея, выключение курсора, тип курсора "мерцание"
  case 12:if(send(z,B00000110,CMND,2000,0)) break; z.step.init++;	//--Движение курсора влево, выключение дисплея
  case 13:if(send(z,B00000001,CMND,2000,0)) break; z.step.init++;	//--Очистка дисплея
  case 14:z.ok.init=true; z.step.init=0; 	break; 					//--Завершение настройки
}
}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			   ОТПРАВКА В ДИСПЛЕЙ КОМАНД И ДАННЫХ (=1 идет вывод, =0 вывод завершен по окончанию или по аварии связи z.ok.link )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_LCD_HD44780:: send (RT_HW_LCD_HD44780_DEVICE &z, uint8_t val, uint8_t cmnd,  uint16_t time, uint8_t tetrade){
switch(z.step.send){default: z.step.send=0;
	case 0: z.ok.cmnd=cmnd;  z.ok.tetrade=tetrade; z.val=val; z.ok.init=false; z.ok.link=true; z.step.send++;
	case 1: switch(z.mode){
			//case 1: send_595 (z);  break;  
			case 2: send_i2c (z);  break; 
			case 3: send_spi (z);  break;  
			case 4: send_bus4(z);  break; 
			}			
			//if(z.ok.sendDevice) {z.ok.send=1; break;} //break;
			if(!z.ok.link) {z.step.send=0; z.ok.send=0; break;}
			if(time==0)    {z.step.send=0; z.ok.send=0; break;}
			z.timeDelay=RT_HW_LCD_HD44780_MICROS+time; 
			                z.step.send++; z.ok.send=1;// break;
	case 2: if(RT_HW_LCD_HD44780_MICROS<z.timeDelay) {z.ok.send=1; break;} // return 1;
						    z.step.send=0; z.ok.send=0; break;  //return 0;	
}
return z.ok.send;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			   ОТПРАВКА В ДИСПЛЕЙ ЧЕРЕЗ I2C (=1 вывод не завершен, =0 - вывод завершен)
// 			   Если об онаружена ошибка связи, сбрасывается (защелка) флаг z.ok.link;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_LCD_HD44780:: send_i2c (RT_HW_LCD_HD44780_DEVICE &z){
	if(!z.ok.tetrade) {device.buff8=(z.val &0xf0)| z.ok.cmnd;} else {device.buff8= z.val <<4;}
	device.buffSend[0] = device.buff8          | BACKLIGHT_ON;	//--Повтор -> необходим импульс не менее >450ns
	device.buffSend[1] = device.buff8 |  FL_EN | BACKLIGHT_ON;	//--Повтор -> необходим импульс не менее >450ns
	device.buffSend[2] = device.buff8          | BACKLIGHT_ON;	//-- 
	device.buffSend[3] =(device.buff8 & ~FL_EN)| BACKLIGHT_ON; //--
	if(!z.ok.tetrade) { device.buff8=(z.val<<4 & 0xf0) | z.ok.cmnd;	
	device.buffSend[4] = device.buff8          | BACKLIGHT_ON;	//--Повтор -> необходим импульс не менее >450ns
	device.buffSend[5] = device.buff8 |  FL_EN | BACKLIGHT_ON;	//--Повтор -> необходим импульс не менее >450ns
	device.buffSend[6] = device.buff8          | BACKLIGHT_ON;	 
	device.buffSend[7] =(device.buff8 & ~FL_EN)| BACKLIGHT_ON;		
	device.buff8=8;}  else device.buff8=4;						//--Установка длины посылки;	 
	Wire.beginTransmission(z.adr); Wire.write(device.buffSend,device.buff8); device.buff8=Wire.endTransmission(); //--Отправка на шину i2c
	if(device.buff8!=0) z.ok.link=0;			//--Установка флага ошибки
return 0;};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			   ОТПРАВКА В ДИСПЛЕЙ ЧЕРЕЗ 4-ПРОВОДНУЮ ШИНУ ДАННЫХ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_LCD_HD44780:: send_bus4(RT_HW_LCD_HD44780_DEVICE &z){	
	digitalWrite(z.buff[0],z.ok.cmnd); 
	//--------------------------------------------------------------------------------------------
	if(!z.ok.tetrade)  device.buff8=z.val>>4;	else device.buff8=z.val & 0x0f; 
	for(int i=2; i<6; i++) {digitalWrite(z.buff[i], (device.buff8 >> (i-2)) & 0x01);}
	digitalWrite(z.buff[1], LOW); digitalWrite(z.buff[1], HIGH); digitalWrite(z.buff[1], LOW); 
	//---------------------------------------------------------------------------------------------
	if(!z.ok.tetrade)   {device.buff8=z.val;
	for(int i=2; i<6; i++) {digitalWrite(z.buff[i], (device.buff8 >> (i-2)) & 0x01);} 
	digitalWrite(z.buff[1], LOW); digitalWrite(z.buff[1], HIGH); digitalWrite(z.buff[1], LOW);}   
return 0;};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			   ОТПРАВКА В ДИСПЛЕЙ ЧЕРЕЗ SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_LCD_HD44780:: send_spi(RT_HW_LCD_HD44780_DEVICE &z){	
	if(!z.ok.tetrade) device.buff8=z.val>>4; else device.buff8= z.val &0x0f;  
	device.buff8=(device.buff8<<2); bitWrite(device.buff8,0,z.ok.cmnd);  	
	spi_595(z,device.buff8,1); spi_595(z,device.buff8,0);
	if(z.ok.tetrade)    return 0;
	device.buff8=z.val; device.buff8=(device.buff8<<2); bitWrite(device.buff8,0,z.ok.cmnd);  
	spi_595(z,device.buff8,1); spi_595(z,device.buff8,0);
	return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			   ОТПРАВКА В ДИСПЛЕЙ ЧЕРЕЗ СДВИГАЮЩИЙ РЕГИСТР SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_LCD_HD44780::spi_595(RT_HW_LCD_HD44780_DEVICE &z, uint8_t val, bool En){	
  bitWrite(val,1,En); digitalWrite(z.adr,0); SPI.transfer(val); digitalWrite(z.adr,1);};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			   ОТПРАВКА В ДИСПЛЕЙ ЧЕРЕЗ СДВИГАЮЩИЙ РЕГИСТР 3 ПИНА
// z.adr=latch, z.buff[0]-clock, z.buff[1] -data;
// данные: bit0->RS(cmmd=0/data=1); bit1-En; bit2-5-> DB4,DB5,DB6,DB7; bit6,bit7 - свободны 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//bool RT_HW_LCD_HD44780:: send_595(RT_HW_LCD_HD44780_DEVICE &z){	
//  switch(z.step.sendExtra){
//	case 0:	if(!z.ok.tetrade)  device.buff8=z.val>>4;	else device.buff8= z.val &0x0f;  
//	        device.buff8=(device.buff8<<2); bitWrite(device.buff8,0,z.ok.cmnd);
//			pin_595(z,device.buff8,1); pin_595(z,device.buff8,0); 
//			if(z.ok.tetrade) {z.step.sendExtra=0; return 1;}
//			z.step.sendExtra++; return 0;
//	case 1: device.buff8=z.val; device.buff8=(device.buff8<<2); bitWrite(device.buff8,0,z.ok.cmnd);   
//			pin_595(z,device.buff8,1); pin_595(z,device.buff8,0); z.step.sendExtra=0; return 1;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			   ОТПРАВКА В ДИСПЛЕЙ ЧЕРЕЗ СДВИГАЮЩИЙ РЕГИСТР 3 ПИНА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_LCD_HD44780:: pin_595(RT_HW_LCD_HD44780_DEVICE &z, uint8_t val, bool En){	
	bitWrite(val,1,En);  
	digitalWrite(z.adr,0); 
	for (uint8_t i=0; i<8; i++) {digitalWrite(z.buff[1], bitRead(val,(7-i)));  digitalWrite(z.buff[0],1); digitalWrite(z.buff[0],0);} 
	digitalWrite(z.adr,1);
};
//==================================================================================================	